/**
 * Scott Root
 * styles2.js
 * Handles the XSLT and CSS
 */

function xml_XSLT_init(type)
{
	if(type =="local")
	{
		var xslFile = xml_getFile("xslt");
		var filename=xslFile.file;
		alert(filename);
		var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
		var documentLength = documentList.length;
		
		for(var i = 0; i < documentLength; i++)
	    {
	    	pageDocument = documentList[i];		
	    	//alert(pageDocument.firstChild.nodeName);
	 	
			var InfoLayer_XSL = pageDocument.createElementNS('http://www.w3.org/1999/xhtml', 'link');
			InfoLayer_XSL.setAttribute('rel', 'stylesheet');
			InfoLayer_XSL.setAttribute('href', filename.path);
			InfoLayer_XSL.setAttribute('type', 'text/xsl');
	    }
    
		pageDocument.documentElement.appendChild(InfoLayer_XSL);
		
	}
	else
	{
		var xslStylesheet;
		var xsltProcessor = new XSLTProcessor();
		var myDOM;
		var xmlDoc;
		
		currentURL=window.content.location.href;  //Current Location (hopefully a .xml file...
		var xslUrl = window.prompt("Enter the URL of the XSL file: ","http://"); //Location of XSL document
		
		// load the xslt file, example1.xsl
		var myXMLHTTPRequest = new XMLHttpRequest();
		if (myXMLHTTPRequest.overrideMimeType) {
			myXMLHTTPRequest.overrideMimeType('text/xml');
		}
		//myXMLHTTPRequest.open("GET", "http://www.w3schools.com/xsl/cdcatalog.xsl", false);
		myXMLHTTPRequest.open("GET",xslUrl , false);
		myXMLHTTPRequest.send(null);
		
		xslStylesheet = myXMLHTTPRequest.responseXML;
		xsltProcessor.importStylesheet(xslStylesheet);
		
		// load the xml file, example1.xml
		myXMLHTTPRequest = new XMLHttpRequest();
		myXMLHTTPRequest.open("GET", currentURL, false);
		myXMLHTTPRequest.send(null);
		
		xmlDoc = myXMLHTTPRequest.responseXML;
		
		var fragment = xsltProcessor.transformToFragment(xmlDoc, document);
		var newDocument = xsltProcessor.transformToDocument(xmlDoc);
	
	  	myDOM = fragment;
	
		var newWin = window.open('','Your transformed document -- XMLDeveloper');
		newWin.document.getElementsByTagName("title")[0].appendChild(newWin.document.createTextNode("Your transformed document -- XMLDeveloper"));
		newWin.document.getElementsByTagName("body")[0].appendChild(fragment);
	}
}

function xml_XSLT_view()
{
	var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
	var documentLength = documentList.length;
	var pi;
	var piType;
	var isSheet=false;
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];		
    	
    	for(var j=0; j<pageDocument.childNodes.length; j++) 
    	{
    		
    	}
    		/*
	    	if(pageDocument.childNodes[j].nodeName == "xml-stylesheet" )
	    	{
	    		isSheet=true;
	    		//Processing instruction
	    		pi=pageDocument.childNodes[j]; 
				alert(pi);
				
			
					//piType=pageDocument.childNodes[j].getAttribute('type');
					piType=pi.getAttribute("type");
					alert(piType);
					if(piType == "text/xsl")
					{
						var href=pageDocument.childNodes[j].getAttributes().getNamedItem("href").getNodeValue();
						window.open(href.nodeValue);
					}		
	    	}
    	}
    	if(isSheet == false)
    	{
    		alert("There appears to not be any XSL associated with this document.");
    	}
    	**/ 
    	
    }	
}

function xml_add_css()
{
	var cssFile = xml_getFile("css");
	var filename=cssFile.file;
	var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
	var documentLength = documentList.length;
	//alert(filename.path);
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];		
    	//alert(pageDocument.firstChild.nodeName);
 	
		var InfoLayer_CSS = pageDocument.createElementNS('http://www.w3.org/1999/xhtml', 'link');
		InfoLayer_CSS.setAttribute('rel', 'stylesheet');
		InfoLayer_CSS.setAttribute('href', filename.path);
		InfoLayer_CSS.setAttribute('type', 'text/css');
    }
    
	pageDocument.documentElement.appendChild(InfoLayer_CSS);
	//this is a comment
}
 
function xml_view_css()
{
	var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
	var documentLength = documentList.length;
	var linkTags;
	//alert(filename.path);
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];
    	if(pageDocument.styleSheets)
		{
			//alert(pageDocument.styleSheets.length +" styles are associated");
			ss=pageDocument.styleSheets;
			for(var j=0; j<ss.length; j++) {
				
				//alert(ss[j].href +" ? "+window.content.location.href);
				
				if(ss[j].href == window.content.location.href)
				{
					alert("This stylesheet is embedded which you can view with view-source.");	
				}
				else
				{
					var n=window.open("","XMLDeveloper - View CSS");
					n.document.write('<frameset cols=20%,80%>');
					n.document.write('<frame src="'+ss[j].href+'" name="f1">');
					n.document.write('<frame src="'+window.content.location.href+'" name="f2">');
					n.document.write('</frameset>');
					n.document.close();
				}
			}
		}
    	
    }
}

function xml_disable_css()
{
	var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
	var documentLength = documentList.length;
	var linkTags;
	
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];
    	if(pageDocument.styleSheets)
		{
			for(var j=0; j<pageDocument.styleSheets.length; j++) 
			{
					pageDocument.styleSheets[j].disabled=true;	
			}	
		}	
    }    
}