/**
 * stats.js
 * @author Scott Root
 * Functionality for the stats section of the toolbar
 */

var xulFile="node_count.xul";  //XUL dialog box file...
var myWin= null;



/**
 * xml_node_count
 * Counts the number of nodes from a given input string
 * @param none
 * @return void
 */
function xml_node_count()
{
	myWin=window.openDialog('chrome://xmldeveloper/content/' + xulFile, 'ExtensionListOptions', 'centerscreen, chrome, resizable');
}

/**
 * Searches a document to find n occurences of a specified node
 * @param string node to find
 * @return void
 */
function doCount(str)
{
	var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
	var documentLength = documentList.length;
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];
		var nodes=pageDocument.getElementsByTagName(str);
		var num_nodes=nodes.length;
		alert("There are "+num_nodes+" nodes named "+str+".");
	}
}