/**
 * xmldeveloper.js
 * 
 * @author Scott Root
 */

function openXUL(xulFile){
   try{
      window.open('chrome://xmldeveloper/content/' + xulFile, 'ExtensionListOptions', 'centerscreen, chrome, resizable');
   }catch(e){
      alert("Error opening window: " + xulFile + " " + e);
   }
}

function xml_getFile(type)
{
	if(type == "xslt")
	{
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, "Select an XSL File", nsIFilePicker.modeOpen);
		fp.appendFilters("*.xsl");
		var res = fp.show();
		if (res == nsIFilePicker.returnOK)
		{
	  		file = fp.file;
			var url="file://"+file.path;
		}
	    else
	    {
	    	fp=null;
	    }
	}
	else if(type == "css")
	{
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, "Select a CSS File", nsIFilePicker.modeOpen);
		fp.appendFilters("*.css");
		var res = fp.show();
		if (res == nsIFilePicker.returnOK)
		{
	  		file = fp.file;
			var url="file://"+file.path;
		}
	    else
	    {
	    	fp=null;
	    }
	}
	else
	{
		fp=null;
	}
	
	return fp;
}