/**
 * @author Scott Root
 * transformations.js
 * Handles all transformation operations
 */



/**
 * @author Scott Root
 * Will handle the processing of XSL files
 * @param type: local or remote
 */
function xml_XSLT_init(type)
{
	netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead");
	//netscape.security.PrivilegeManager.enablePrivilege("UniversalFileRead");
	var xslStylesheet;
	var xsltProcessor = new XSLTProcessor();
	var myDOM;
	var xmlDoc, xslUrl, tmpDoc;
	var currentURL=window.content.location.href;  //Current Location (hopefully a .xml file...
	
	if(type =="local")
	{
	
		var picker = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker); 
	    //picker.appendFilters(picker.filterXML | picker.filterXSL);
	    picker.defaultExtension = ".xsl";
	    picker.init(window, "Select File", picker.modeOpen);
	    var rv = picker.show();
	    if (rv == picker.returnCanel)
	      return;
	
	    //use the io service to conver the file to a uri
	    var ioSvc = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	    var uri = ioSvc.newFileURI(picker.file);
	    xslUrl = uri.spec;
	  
		var data = "";
		var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
		                        .createInstance(Components.interfaces.nsIFileInputStream);
		var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
		                        .createInstance(Components.interfaces.nsIScriptableInputStream);
		fstream.init(picker.file, -1, 0, 0);
		sstream.init(fstream); 
		
		var str = sstream.read(4096);
		while (str.length > 0) {
		  data += str;
		  str = sstream.read(4096);
		}
		var parser = new DOMParser();
		var newDoc = parser.parseFromString(data, "text/xml");
		sstream.close();
		fstream.close();
		//var serializer = new XMLSerializer();
		//var xmlstr = serializer.serializeToString(newDoc);
		//alert(xmlstr);
		/*if(newDoc.getElementsByTagName('xsl:output'))
		{
			var xEle = newDoc.getElementsByTagName('xsl:output');
			for(var z=0; z<newDoc.firstChild.childNodes.length; z++) {
				//alert(newDoc.firstChild.childNodes[z].nodeName + " :: " + newDoc.firstChild.childNodes[z].nodeValue);
				if(newDoc.firstChild.childNodes[z].nodeName == 'xsl:output')
				{ 
					alert("YUP");
					if(newDoc.getElementsByTagName('xsl:output'))
					{
						//var ele = newDoc.getElementsByTagName('xsl:output');
						//alert(ele.length);
						//alert(ele[0].getAttribute('method'));
						//XPATH : //xsl:output@method
						var arrr=xml_xPathSearch("xsl:output@method");
						alert(arrr.length);
					}
				}
			}
			alert(xEle.length);
			for(var j=0; j<xEle.length; j++) 
			{
				alert(xEle[j].getAttribute('method'));
				if(xEle[j].getAttribute('method') != 'html')
				{
					alert("It appears that our XSL file does not include an xsl:output element \n" +
							"with the attribute method=\"html\"" +
							"Please ammend our file to reflect this change.");
					return;
				}
			}
		}*/
		xsltProcessor.importStylesheet(newDoc);
	}
	else
	{
		//Location of XSL document
		xslUrl = window.prompt("Enter the URL of the XSL file: ","http://");
		var myXMLHTTPRequest = new XMLHttpRequest();
	   	if (myXMLHTTPRequest.overrideMimeType) {
			myXMLHTTPRequest.overrideMimeType('text/xml');
		}
	   	myXMLHTTPRequest.open("GET", xslUrl, false);
	   	myXMLHTTPRequest.send(null); 
	   	
	   	xslStylesheet = myXMLHTTPRequest.responseXML;
	   	
		xsltProcessor.importStylesheet(xslStylesheet); 	
	}    
	  	
	// load the xml file
	myXMLHTTPRequest = new XMLHttpRequest();
	if (myXMLHTTPRequest.overrideMimeType) {
		myXMLHTTPRequest.overrideMimeType('text/xml');
	}
	myXMLHTTPRequest.open("GET", currentURL, false);
	myXMLHTTPRequest.send(null);
	
	xmlDoc = myXMLHTTPRequest.responseXML;
	
	var fragment = xsltProcessor.transformToFragment(xmlDoc, document);
	var newDocument = xsltProcessor.transformToDocument(xmlDoc);

  	myDOM = fragment;
	
	var newWin = window.open('','Your transformed document -- XMLDeveloper');
	newWin.document.getElementsByTagName("title")[0].appendChild(newWin.document.createTextNode("Your transformed document -- XMLDeveloper"));
	newWin.document.getElementsByTagName("body")[0].appendChild(fragment);
	

}

/**
 * @author Scott Root
 * The goal here is to be able to view linked or applied XSLT
 * Is this possible since the document.styleSheets method does not look for XSL?!
 */
 
function xml_XSLT_view()
{
	var documentList = xmldeveloper_getDocuments(xmldeveloper_getContentWindow());
	var documentLength = documentList.length;
	var pi;
	var piType;
	var isSheet=false;
	for(var i = 0; i < documentLength; i++)
    {
    	pageDocument = documentList[i];		
    	
    	for(var j=0; j<pageDocument.childNodes.length; j++) 
    	{
    		
    	}
    		/*
	    	if(pageDocument.childNodes[j].nodeName == "xml-stylesheet" )
	    	{
	    		isSheet=true;
	    		//Processing instruction
	    		pi=pageDocument.childNodes[j]; 
				alert(pi);
				
			
					//piType=pageDocument.childNodes[j].getAttribute('type');
					piType=pi.getAttribute("type");
					alert(piType);
					if(piType == "text/xsl")
					{
						var href=pageDocument.childNodes[j].getAttributes().getNamedItem("href").getNodeValue();
						window.open(href.nodeValue);
					}		
	    	}
    	}
    	if(isSheet == false)
    	{
    		alert("There appears to not be any XSL associated with this document.");
    	}
    	**/ 
    	
    }	
}